import { ElementRef } from '@angular/core';
import { BaseMixin, DynamicClock } from 'ngx-component-mixins';
import { B2World, B2Body, B2Fixture } from 'that-box2d-library';
declare const BodyComponent_base: import("ngx-component-mixins/Base").Constructor<import("ngx-component-mixins/Subscriber").ISubscriber> & typeof BaseMixin;
/**
 * A component for attaching a Box2D body to a Angular Component
 */
export declare class BodyComponent extends BodyComponent_base {
    private hostElement;
    constructor(hostElement: ElementRef);
    /**
     * The body to which this component is associated
     */
    body: B2Body;
    /**
     * The world to which this body belongs
     */
    world: B2World;
    /**
     * The dynamic clock
     */
    clock: DynamicClock;
    /**
     * The SVG path
     */
    pathElement: ElementRef;
    /**
     * The fixtures that make up the body
     */
    fixtures: Array<B2Fixture>;
    ngOnInit(): void;
    /**
     * Process a tick of the clock
     */
    doTick(): void;
    /**
     * Set the position of each fixture
     */
    doSetFixturePositions(): void;
}
export {};
