import { B2Vec2, B2PolygonShape } from 'that-box2d-library';
/**
 * A utility class for performing SVG maths
 */
export var SVGMathsUtility = {
    /**
     * Convert a Box2D fixture into an SVG path
     */
    fixturePath: function (body, fixture) {
        var path = '', shape = fixture.m_shape;
        // If the Shape is a Polygon
        if (shape instanceof B2PolygonShape) {
            var polyShape_1 = shape;
            polyShape_1.m_vertices.forEach(function (v, i) {
                if (i < polyShape_1.m_count) {
                    var vw = body.GetWorldPoint(v, new B2Vec2(0, 0));
                    path += '' + (i === 0 ? 'M ' : 'L ') + vw.x + ' ' + vw.y + ' ';
                }
            });
            path +=
                'L ' +
                    body.GetWorldPoint(polyShape_1.m_vertices[0], new B2Vec2(0, 0)).x +
                    ' ' +
                    body.GetWorldPoint(polyShape_1.m_vertices[0], new B2Vec2(0, 0)).y;
        }
        // Done
        return path;
    }
};
//# sourceMappingURL=svgmaths.utility.js.map