import { OnInit, ElementRef } from '@angular/core';
import { BaseMixin, DynamicClock } from 'ngx-component-mixins';
import { B2World } from 'that-box2d-library';
declare const WorldComponent_base: import("ngx-component-mixins/Base").Constructor<import("ngx-component-mixins/Subscriber").ISubscriber> & typeof BaseMixin;
/**
 * A component for managing a Box2D world
 */
export declare class WorldComponent extends WorldComponent_base implements OnInit {
    private hostElement;
    constructor(hostElement: ElementRef);
    /**
     * How quickly does time tick
     * (Units are abitrary)
     */
    speed: number;
    /**
     * The Box2D world associated with this component
     */
    world: B2World;
    /**
     * The dynamic clock which governs the world time
     */
    clock: DynamicClock;
    /**
     * The number of velocity calculations to perform each tick
     */
    velocityIterations: number;
    /**
     * The number of position calculations to perform each tick
     */
    positionIterations: number;
    ngOnInit(): void;
    /**
     * Process a tick of the clock
     */
    doTick(diff: number): void;
}
export {};
