var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ElementRef } from '@angular/core';
import { BaseMixin, DynamicClock, SubscriberMixin } from 'ngx-component-mixins';
import { B2World } from 'that-box2d-library';
/**
 * A component for managing a Box2D world
 */
var WorldComponent = /** @class */ (function (_super) {
    __extends(WorldComponent, _super);
    /* CONSTRUCTOR */
    function WorldComponent(hostElement) {
        var _this = _super.call(this) || this;
        _this.hostElement = hostElement;
        /* INPUTS */
        /**
         * How quickly does time tick
         * (Units are abitrary)
         */
        _this.speed = 5;
        /**
         * The number of velocity calculations to perform each tick
         */
        _this.velocityIterations = 6;
        /**
         * The number of position calculations to perform each tick
         */
        _this.positionIterations = 2;
        _this.hostElement.nativeElement.style.opacity = 0;
        _this.hostElement.nativeElement.style.transition = 'opacity 0.3s';
        return _this;
    }
    /* LIFECYCLE METHODS */
    WorldComponent.prototype.ngOnInit = function () {
        var _this = this;
        // Subscribe to dynamic clock
        this.subscribeTo(this.clock, function (_a) {
            var diff = _a.diff;
            return _this.doTick(diff);
        });
        // Fade in
        setTimeout(function () {
            _this.hostElement.nativeElement.style.opacity = 1;
        }, 500);
    };
    /* METHODS */
    /**
     * Process a tick of the clock
     */
    WorldComponent.prototype.doTick = function (diff) {
        if (diff) {
            this.world.Step(diff / ((11 - this.speed) * 40), this.velocityIterations, this.positionIterations);
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], WorldComponent.prototype, "speed", void 0);
    __decorate([
        Input(),
        __metadata("design:type", B2World
        /**
         * The dynamic clock which governs the world time
         */
        )
    ], WorldComponent.prototype, "world", void 0);
    __decorate([
        Input(),
        __metadata("design:type", DynamicClock
        /**
         * The number of velocity calculations to perform each tick
         */
        )
    ], WorldComponent.prototype, "clock", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], WorldComponent.prototype, "velocityIterations", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], WorldComponent.prototype, "positionIterations", void 0);
    WorldComponent = __decorate([
        Component({
            selector: 'svg[box2d]',
            template: '<ng-content></ng-content>'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], WorldComponent);
    return WorldComponent;
}(SubscriberMixin(BaseMixin)));
export { WorldComponent };
//# sourceMappingURL=world.component.js.map